#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <stdlib.h>
#include <linux/if_ether.h>    // For ETH_ALEN

#include <linux/if_pppox.h>
#include <linux/if_pppol2tp.h>

#include "testlib.h"

int main()
{
  int server_sock1, session_sock1;
  int server_sock2, session_sock2;
  
  server_sock1 = OpenUDPSocket( 1701 );
  session_sock1 = OpenPPPoL2TPSocket();

  server_sock2 = OpenUDPSocket( 1702 );
  session_sock2 = OpenPPPoL2TPSocket();

  fcntl( server_sock1,  F_SETFD, FD_CLOEXEC );
  fcntl( session_sock1, F_SETFD, FD_CLOEXEC );
  fcntl( server_sock2,  F_SETFD, FD_CLOEXEC );
  fcntl( session_sock2, F_SETFD, FD_CLOEXEC );
  
  ConnectSock( session_sock1, server_sock1, 1702, 1, 2, 3, 4 );
  ConnectSock( session_sock2, server_sock2, 1701, 3, 4, 1, 2 );

  system( "tests/subtest-proc" );
  
  StartPPPDaemon( session_sock1 );
  StartPPPDaemon( session_sock2  );
  
  fprintf( stderr, "Press any key to continue\n" );
  {
    char buf[16];
    fgets( buf, 10, stdin );
  }
  fprintf ( stderr, "Closing server2 socket\n" );  
  close( server_sock2 );
  fprintf ( stderr, "Closing session2 socket\n" );  
  close( session_sock2 );
  fprintf ( stderr, "Closing session1 socket\n" );  
  close( session_sock1 );
  fprintf ( stderr, "Closing server1 socket\n" );  
  close( server_sock1 );
  
  return 0;
}
